'**************************************************************************
'*                       LEADVIEW 3.0 for Windows 
'**************************************************************************

'$DEFINE DEBUG  ''Define for script development/debugging

'$INCLUDE 'setupapi.inc'
'$INCLUDE 'msdetect.inc'

''Dialog ID's
CONST WELCOME       = 100
CONST ASKQUIT       = 200
CONST DESTPATH      = 300
CONST EXITFAILURE   = 400
CONST EXITQUIT      = 600
CONST EXITSUCCESS   = 700
CONST APPHELP       = 900
CONST BADPATH       = 6400
CONST ABOUT         = 1100
''Bitmap ID
CONST LOGO = 2

GLOBAL DEST$        ''Default destination directory.
GLOBAL OPTCUR$      ''Option selection from option dialog.

DECLARE SUB Install
DECLARE FUNCTION MakePath (szDir$, szFile$) AS STRING


INIT:
    CUIDLL$ = "mscuistf.dll"            ''Custom user interface dll
    HELPPROC$ = "FHelpDlgProc"          ''Help dialog procedure

    SetBitmap CUIDLL$, LOGO
    SetTitle "Imagehandler 4.0 for Windows Setup"

    szInf$ = GetSymbolValue("STF_SRCINFPATH")
    IF szInf$ = "" THEN
        szInf$ = GetSymbolValue("STF_CWDDIR") + "leadview.INF"
    END IF
    ReadInfFile szInf$

    OPTCUR$ = "1"
    DEST$ = "C:\imagehan"

'$IFDEF DEBUG
    i% = SetSizeCheckMode(scmOff)    '' could use scmOff; def = scmOnFatal
    WinDrive$ = MID$(GetWindowsDir, 1, 1)
    IF IsDriveValid(WinDrive$) = 0 THEN
        i% = DoMsgBox("Windows drive ('"+WinDrive$+"') is not a valid drive.", "DEBUG", MB_TASKMODAL+MB_ICONHAND+MB_OK)
        GOTO QUIT
    END IF
'$ENDIF ''DEBUG


WELCOME:
    sz$ = UIStartDlg(CUIDLL$, WELCOME, "FInfoDlgProc", APPHELP, HELPPROC$)
    IF sz$ = "CONTINUE" THEN
        UIPop 1
    ELSE
        GOSUB ASKQUIT
        GOTO WELCOME
    END IF

GETPATH:
    SetSymbolValue "EditTextIn", DEST$
    SetSymbolValue "EditFocus", "END"

GETPATHL1:
    sz$ = UIStartDlg(CUIDLL$, DESTPATH, "FEditDlgProc", APPHELP, HELPPROC$)
    DEST$ = GetSymbolValue("EditTextOut")

    IF sz$ = "CONTINUE" THEN
        IF IsDirWritable(DEST$) = 0 THEN
            GOSUB BADPATH
            GOTO GETPATHL1
        END IF
        UIPop 1
    ELSEIF sz$ = "REACTIVATE" THEN
        GOTO GETPATHL1
    ELSEIF sz$ = "BACK" THEN
        UIPop 1
        GOTO WELCOME
    ELSE
        GOSUB ASKQUIT
        GOTO GETPATH
    END IF

    Install

QUIT:

    ON ERROR GOTO ERRQUIT

    IF ERR = 0 THEN
        dlg% = EXITSUCCESS
    ELSEIF ERR = STFQUIT THEN
        dlg% = EXITQUIT
    ELSE
        dlg% = EXITFAILURE
    END IF

QUITL1:
    sz$ = UIStartDlg(CUIDLL$, dlg%, "FInfo0DlgProc", 0, "")
    IF sz$ = "REACTIVATE" THEN
        GOTO QUITL1
    END IF
    UIPop 1

    END

ERRQUIT:
    i% = DoMsgBox("Setup sources were corrupted, call 549-5532!", "Setup Message", MB_OK+MB_TASKMODAL+MB_ICONHAND)
    END

BADPATH:
    sz$ = UIStartDlg(CUIDLL$, BADPATH, "FInfo0DlgProc", 0, "")
    IF sz$ = "REACTIVATE" THEN
        GOTO BADPATH
    END IF
    UIPop 1
    RETURN

ASKQUIT:
    sz$ = UIStartDlg(CUIDLL$, ASKQUIT, "FQuitDlgProc", 0, "")

    IF sz$ = "EXIT" THEN
        UIPopAll
        ERROR STFQUIT
    ELSEIF sz$ = "REACTIVATE" THEN
        GOTO ASKQUIT
    ELSE
        UIPop 1
    END IF
    RETURN

'**
'** Purpose:
'**     Builds the copy list and performs all installation operations.
'** Arguments:
'**     none.
'** Returns:
'**     none.
'*************************************************************************
SUB Install STATIC

    SrcDir$ = GetSymbolValue("STF_SRCDIR")
    CreateDir DEST$, cmoNone

    OpenLogFile MakePath(DEST$, "LOGFILE.OUT"), 0
    WriteToLogFile ""
    WriteToLogFile "  User chose as destination directory: '" + DEST$ + "'"
    WriteToLogFile "  User chose option: '" + OPTCUR$ + "'"
    WriteToLogFile ""
    WriteToLogFile "May have had to create the directory: " + DEST$
    WriteToLogFile ""

    WinDir$ = GetWindowsDir
    WinSystemDir$ = MakePath(GetWindowsDir,"system")
    AddSectionFilesToCopyList "Files", SrcDir$, DEST$
    CopyFilesInCopyList

    CreateIniKeyValue "WIN.INI", "Extensions", "CMP", "Handler.EXE ^.CMP ", cmoNone
    CreateIniKeyValue "WIN.INI", "Extensions", "JPG", "Handler.exe ^.JPG ", cmoNone
    CreateIniKeyValue "WIN.INI", "Extensions", "JFF", "Handler.exe ^.JFF ", cmoNone
    CreateIniKeyValue "WIN.INI", "Extensions", "JTF", "Handler.exe ^.JTF ", cmoNone
    CreateIniKeyValue "WIN.INI", "Extensions", "TIF", "Handler.exe ^.TIF ", cmoNone
    CreateIniKeyValue "WIN.INI", "Extensions", "BMP", "Handler.exe ^.BMP ", cmoNone
    CreateIniKeyValue "WIN.INI", "Extensions", "TGA", "Handler.exe ^.TGA ", cmoNone
    CreateIniKeyValue "WIN.INI", "Extensions", "GIF", "Handler.exe ^.GIF ", cmoNone
    CreateIniKeyValue "WIN.INI", "Extensions", "PCX", "Handler.exe ^.PCX ", cmoNone
    CreateIniKeyValue "WIN.INI", "Extensions", "WMF", "Handler.exe ^.WMF ", cmoNone
    CreateIniKeyValue "WIN.INI", "Extensions", "CAL", "Handler.exe ^.CAL ", cmoNone

    CreateProgmanGroup "Imagehandler 4.0", "", cmoNone
    ShowProgmanGroup  "Imagehandler 4.0", 1, cmoNone
    CreateProgmanItem "Imagehandler 4.0", "Imagehandler 4.0 Paint & Draw", MakePath(DEST$,"Handler.exe"), "", cmoOverwrite
    CreateProgmanItem "Imagehandler 4.0", "LEADTOOLS 4.5 DEMO", MakePath(DEST$,"demo.exe"), "", cmoOverwrite
    CreateProgmanItem "Imagehandler 4.0", "SCROLL & ZOOM Sample", MakePath(DEST$,"scrlzoom.exe"), "", cmoOverwrite
    CreateProgmanItem "Imagehandler 4.0", "LEAD WndClass Sample", MakePath(DEST$,"regclass.exe"), "", cmoOverwrite
    CreateProgmanItem "Imagehandler 4.0", "Paint Effect Sample", MakePath(DEST$,"painteff.exe"), "", cmoOverwrite
    CreateProgmanItem "Imagehandler 4.0", "Read ME First", "Write.exe "+MakePath(DEST$,"Readme.wri"), "", cmoOverwrite
    RUN "Write.exe "+MakePath(DEST$,"Readme.wri")


    CloseLogFile

END SUB



'**
'** Purpose:
'**     Appends a file name to the end of a directory path,
'**     inserting a backslash character as needed.
'** Arguments:
'**     szDir$  - full directory path (with optional ending "\")
'**     szFile$ - filename to append to directory
'** Returns:
'**     Resulting fully qualified path name.
'*************************************************************************
FUNCTION MakePath (szDir$, szFile$) STATIC AS STRING
    IF szDir$ = "" THEN
        MakePath = szFile$
    ELSEIF szFile$ = "" THEN
        MakePath = szDir$
    ELSEIF MID$(szDir$, LEN(szDir$), 1) = "\" THEN
        MakePath = szDir$ + szFile$
    ELSE
        MakePath = szDir$ + "\" + szFile$
    END IF
END FUNCTION

